--- /usr/lib/password-store/extensions/otp.bash	2023-11-15 16:56:19.083879622 +0100
+++ ./.password-store/.extensions/otp.bash	2023-11-15 16:57:53.015657338 +0100
@@ -16,8 +16,8 @@
 #    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 # []
 
-VERSION="1.1.1"
-OATH=$(which oathtool)
+# hacked to use Pass::OTP instead of oathtool
+VERSION="1.1.1-perl"
 
 ## source:  https://gist.github.com/cdown/1163649
 urlencode() {
@@ -305,7 +305,7 @@
 }
 
 cmd_otp_code() {
-  [[ -z "$OATH" ]] && die "Failed to generate OTP code: oathtool is not installed."
+  perldoc -l 'Pass::OTP' &>/dev/null || die "Failed to generate OTP code: Pass::OTP is not installed."
 
   local opts clip=0
   opts="$($GETOPT -o c -l clip -n "$PROGRAM" -- "$@")"
@@ -331,21 +331,18 @@
     fi
   done < <(echo "$contents")
 
-  local cmd
+  local script
   case "$otp_type" in
-    totp)
-      cmd="$OATH -b --totp"
-      [[ -n "$otp_algorithm" ]] && cmd+=$(echo "=${otp_algorithm}"|tr "[:upper:]" "[:lower:]")
-      [[ -n "$otp_period" ]] && cmd+=" --time-step-size=$otp_period"s
-      [[ -n "$otp_digits" ]] && cmd+=" --digits=$otp_digits"
-      cmd+=" $otp_secret"
-      ;;
-
     hotp)
       local counter=$((otp_counter+1))
-      cmd="$OATH -b --hotp --counter=$counter"
-      [[ -n "$otp_digits" ]] && cmd+=" --digits=$otp_digits"
-      cmd+=" $otp_secret"
+      ;&
+
+    totp)
+      read -d'' -r script <<- eof
+				use Pass::OTP       qw/otp/;
+				use Pass::OTP::URI  qw/parse/;
+				print otp(parse('$otp_uri'));
+			eof
       ;;
 
     *)
@@ -353,7 +350,7 @@
       ;;
   esac
 
-  local out; out=$($cmd) || die "$path: failed to generate OTP code."
+  local out; out=$(perl < <(echo "$script")) || die "$path: failed to generate OTP code."
 
   if [[ "$otp_type" == "hotp" ]]; then
     # Increment HOTP counter in-place
